﻿using System;
using System.Windows.Forms;
using System.Runtime.InteropServices;

namespace ScreenLock {
    public partial class Form3 : Form {

        private TextBox passwordTextBox; 
        private Button unlockButton; 
        private const string CorrectPassword = "password"; 
        private bool isPasswordRight = false;  

        
        private const int WH_KEYBOARD_LL = 13;
        private const int WM_KEYDOWN = 0x0100;
        private const int WM_SYSKEYDOWN = 0x0104;

        
        private const int VK_TAB = 0x09;
        private const int VK_LWIN = 0x5B;
        private const int VK_RWIN = 0x5C;

        
        private delegate IntPtr LowLevelKeyboardProc(int nCode, IntPtr wParam, IntPtr lParam);

        
        private static IntPtr _hookID = IntPtr.Zero;
        private static LowLevelKeyboardProc _proc = HookCallback;

      
        public Form3() {
            InitializeComponent();
            InitializeUI(); 
            _hookID = SetHook(_proc);  
        }

      
        private void InitializeUI() {         
            passwordTextBox = new TextBox {
                Location = new System.Drawing.Point(865, 500),
                PasswordChar = '*',  
                Width = 150
            };
           
            unlockButton = new Button {
                Location = new System.Drawing.Point(905, 550),
                Text = "Unlock"
            };
            unlockButton.Click += UnlockButton_Click;  
           
            Controls.Add(passwordTextBox);
            Controls.Add(unlockButton);
            
            this.WindowState = FormWindowState.Maximized;
            this.FormBorderStyle = FormBorderStyle.None;
            this.Bounds = Screen.PrimaryScreen.WorkingArea;
        }

        
        private void UnlockButton_Click(object sender, EventArgs e) {
            string enteredPassword = passwordTextBox.Text;  
            if (enteredPassword == CorrectPassword) {            
                isPasswordRight = true;
                Application.Exit();
            } else {               
                MessageBox.Show("Неверный пароль", "Ошибка", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
        }

        
        private void Form3_Resize(object sender, EventArgs e) {          
            if (WindowState == FormWindowState.Minimized) {
                this.WindowState = FormWindowState.Normal;
            }
        }
      
        private void Form3_Load(object sender, EventArgs e) { }

        
        protected override void OnFormClosing(FormClosingEventArgs e) {          
            if (isPasswordRight) e.Cancel = false;
            else e.Cancel = true;
            base.OnFormClosing(e);
        }

        
        [DllImport("user32.dll", CharSet = CharSet.Auto, SetLastError = true)]
        private static extern IntPtr SetWindowsHookEx(int idHook, LowLevelKeyboardProc lpfn, IntPtr hMod, uint dwThreadId);

        [DllImport("user32.dll", CharSet = CharSet.Auto, SetLastError = true)]
        [return: MarshalAs(UnmanagedType.Bool)]
        private static extern bool UnhookWindowsHookEx(IntPtr hhk);

        [DllImport("user32.dll", CharSet = CharSet.Auto, SetLastError = true)]
        private static extern IntPtr CallNextHookEx(IntPtr hhk, int nCode, IntPtr wParam, IntPtr lParam);

        [DllImport("kernel32.dll", CharSet = CharSet.Auto, SetLastError = true)]
        private static extern IntPtr GetModuleHandle(string lpModuleName);

        
        private static IntPtr SetHook(LowLevelKeyboardProc proc) {
            using (System.Diagnostics.Process curProcess = System.Diagnostics.Process.GetCurrentProcess())
            using (System.Diagnostics.ProcessModule curModule = curProcess.MainModule) {
              
                return SetWindowsHookEx(WH_KEYBOARD_LL, proc, GetModuleHandle(curModule.ModuleName), 0);
            }
        }

        
        private static IntPtr HookCallback(int nCode, IntPtr wParam, IntPtr lParam) {
            if (nCode >= 0 && (wParam == (IntPtr)WM_KEYDOWN || wParam == (IntPtr)WM_SYSKEYDOWN)) {
               
                int vkCode = Marshal.ReadInt32(lParam);
                if ((vkCode == VK_TAB && Control.ModifierKeys == Keys.Alt) || vkCode == VK_LWIN || vkCode == VK_RWIN) {

                    return (IntPtr)1;
                }
            }

            return CallNextHookEx(_hookID, nCode, wParam, lParam);
        }
    }
}